#
# audio control frame
#
# $Id: audioctl.tcl,v 1.17 1998/09/30 11:23:44 dor Exp $
#

set counter 0
proc audioctl_check {} {
    global Session counter

    if [file exists "/var/tmp/pmm_audioctl.pid"] {
	control_send "*/au_ctrl/* active $Session(update_interval)"
    } else {
	if [info exists Session(f_audio_control)] {
	    disable_win $Session(f_audio_control)
	    $Session(f_audio_control).monitor configure -foreground gray
	    set audioctl_flag 0
	}
	# start audio control tool from the mailcap
	set p " audioctl/*; active=$Session(update_interval)"
	if {[catch { set aid [application $p] } msg]} {
	    if { $counter < 1 } {
		set counter [expr $counter + 1]
		isc_message "$msg
MINT starting without audio control but will be trying later"
	    }
	}
    }
    after 15000 audioctl_check
}

proc audioctl {} {
    global Session record play monitor audioctl_flag conf

    grid configure \
	[button $Session(f_audio_control).in -bitmap "$record(port)_in" -borderwidth 1 -command {control_send "*/au_ctrl/* set record(port) +"}] -row 1 -column 1
    grid configure \
	[button $Session(f_audio_control).out -bitmap "$play(port)_out" -borderwidth 1 -command {control_send "*/au_ctrl/* set play(port) +"}] -row 2 -column 1
    grid configure \
	[label $Session(f_audio_control).monitor -text "Monitor" ] -row 3 -column 1
    grid configure \
	[scale $Session(f_audio_control).rec_gain -orient horizontal -borderwidth 1 -from 0 -to 100 -showvalue true -variable record(gain)] -row 1 -column 2
    grid configure \
	[scale $Session(f_audio_control).play_gain -orient horizontal -borderwidth 1 -from 0 -to 100 -showvalue true -variable play(gain)] -row 2 -column 2
    grid configure \
	[scale $Session(f_audio_control).monitor_gain -orient horizontal -borderwidth 1 -from 0 -to 100 -showvalue true -variable monitor(gain)] -row 3 -column 2
    
    # bindings to scales
    bind $Session(f_audio_control).rec_gain <ButtonRelease-1> "gain_send \"record(gain)\""
    bind $Session(f_audio_control).play_gain <ButtonRelease-1> "gain_send \"play(gain)\""
    bind $Session(f_audio_control).monitor_gain <ButtonRelease-1> "gain_send \"monitor(gain)\""
    bind $Session(f_audio_control).rec_gain <ButtonRelease-2> "gain_send \"record(gain)\""
    bind $Session(f_audio_control).play_gain <ButtonRelease-2> "gain_send \"play(gain)\""
    bind $Session(f_audio_control).monitor_gain <ButtonRelease-2> "gain_send \"monitor(gain)\""
    
}


proc gain_send {tag} {
    global conf record play monitor
    control_send "*/au_ctrl/* set $tag [subst $[subst $tag]]"
}

proc audioctl_request {msg} {
    global Session record play monitor audioctl_flag 

    set tag [lindex $msg 0]
    set value [lindex $msg 1]  
  switch $tag {
	monitor(gain) -
	play(gain) -
	record(gain) {
	    if {$tag == "play(gain)"} {
		if {![info exists play(old_gain)]} {
		    set play(old_gain) $value
		}
	    }
	    if [info exists Session(f_audio_control)] {
		#only enable entry if necessary
		if {[$Session(f_audio_control).in cget -state] == "disabled"} {
		    enable_win $Session(f_audio_control)
		}	
		$Session(f_audio_control).monitor configure -foreground black
	    }
	    set $tag $value
	}
	record(port) {
	    set $tag $value
	    if [info exists Session(f_audio_control)] {
		#only enable entry if necessary
		if {[$Session(f_audio_control).in cget -state] == "disabled"} {
		    enable_win $Session(f_audio_control)	
		}
		$Session(f_audio_control).monitor configure -foreground black
		if [catch {$Session(f_audio_control).in configure \
			       -bitmap "${value}_in"}] {
		    $Session(f_audio_control).in configure -bitmap "invalid_in"
		}
	    }
	}
	play(port) {
	    set $tag $value
	    if {![info exists play(old_port)]} {
		set play(old_port) $value
	    }
	    if [info exists Session(f_audio_control)] {
		#only enable entry if necessary
		if {[$Session(f_audio_control).in cget -state] =="disabled"} {
		    enable_win $Session(f_audio_control)
		}	
		$Session(f_audio_control).monitor configure -foreground black
		if [catch {$Session(f_audio_control).out configure \
			       -bitmap "${value}_out"}] {
		    $Session(f_audio_control).out configure \
			-bitmap "invalid_out"
		}
	    }
	}
  }
}










