#
# Remote control functions using UDP
#
# $Id: control_udp.tcl,v 1.7 1998/09/04 10:22:25 isc Exp $
#

#
# Source and destination port on all multicast packets is 5010
# (sending port uses bind(), so that we have no way of knowing whether
# we see our own transmissions or those from another process.  
#

proc control_read_udp {sock} {
    set msg [gets $sock]

    set index [string first " " $msg]
    set pmm_msg [string range $msg [expr $index+1] end]

    #puts stderr "pmm -> $msg"
    
    if {[string match "*/sip/*" [lindex $msg 0]]} {
	# check whether it's a sip request
	read_sip_request $pmm_msg
    } elseif {[string match "*/mint/" [lindex $msg 0]]} {
    # check whether it's a mint request
	 mint_request  $msg
    } elseif {[string match "*/au_ctrl/*" [lindex $msg 0]]} {
    # check whether it's a audioctl request
	 audioctl_request $pmm_msg
    } else {
	control_eval $msg
    }
}

proc control_init_udp {controller} {
    global cdest cfile c

    set host [lindex $controller 1]
    set port [lindex $controller 2]
    set c [udp $host $port]
    Tcl_SetSockBuffer $c
    fconfigure $c -ttl 0  
    fconfigure $c -buffering none
    fconfigure $c -member 1
    fileevent $c readable {control_read_udp $c}
      
    # define sending procedure
    proc control_send {msg} {
	global cdest cfile prog_name debug c
 	
	if {[lsearch $debug pmm] >= 0} {puts "$prog_name -> $msg"}
	puts -nonewline $c $msg 

    }
}
