#
# $Id: help.tcl,v 1.20 1998/10/06 09:34:10 isc Exp $
#

#********** Error messages *********************************
proc isc_message { msg } {
    global delay
    set w .isc_message
    if { [winfo exists $w] } {
	destroy $w
    }
    toplevel $w
    set x [expr [winfo screenwidth .] /2 ]
    set y [expr [winfo screenheight .] /2 ]
    wm geometry $w +$x+$y
    wm title $w "ISC Error Message"
    frame $w.head
    
    after [expr $delay(display) * 3] " if [winfo exists $w] {destroy $w}"
    pack \
	$w.head \
	[label $w.l -text $msg] \
	[button $w.b -text "Close" -command "destroy $w"] \
	-side top
}

#
# Help routine: view help with browser
#
proc try_open_url {w url} {
    if [catch { exec netscape -remote $url } ] {
	$w configure -state disabled
	if [ catch { exec netscape & } ] {
	    isc_message "Could not open netscape, 
please make sure that it is in your path
or call it explicitly to be able to use
$url " } else {
    open_url $w $url 
}
    }
}
# how often to try to open an url
set open_repeat 3
proc open_url {w url} {
    global open_repeat
    if [catch { exec netscape -remote $url } ] {
	set open_repeat [expr $open_repeat -1]
	if { $open_repeat >= 0 } {
	    after 10000 open_url $w $url
	} else {
	    isc_message "Could not open Handbook in 
$url"
	    $w configure -state normal
	    set open_repeat 3
	}
    } else {
	$w configure -state normal
	set open_repeat 3
    }
}    

proc help { w } {
    global Hand_URL
    try_open_url $w $Hand_URL 
}



proc about {w} {
  global version Copy_URL
    
    if [winfo exists $w.right] {destroy $w.right}
    toplevel $w.right
    wm title $w.right "Copyright Information"
    frame $w.right.text -relief groove -borderwidth 2
    set t [text $w.right.text.help -wrap word -width 72 -height 5]
    $t insert end {MInT was mainly produced by GMD Fokus, 
Technical University Berlin and Columbia University
with support from the German Research Network (DFN)
    }
    $t configure -state disabled
   
# create the help frame
    set w_copy [frame $w.right.frame]
    pack \
    [button $w_copy.detail -text "Detailed Copyright" -command "try_open_url  $w_copy.detail $Copy_URL"]\
	[button $w_copy.dissmiss -text "Close"  -command "destroy $w.right"]\
	-side left -fill both -expand yes

    pack $t
    pack $w.right.text \
	$w_copy \
	-side top -fill both -expand yes
}

#this is the part where the Balloonmessages are 
proc help_balloon {flag} {    
    switch $flag {
	create_session { 
	    set msg "Press here to 
create the session"
	    return $msg
	}
	Media {
	     set msg "Choose media
types that are
listed here"
	    return $msg
	}
	Destination {
	    set msg "Enter here
the destination 
IP address or 
the unicast host"
	    return $msg
	}
	Local {
	    set msg "Enter here the
name of the interface from
which to send the data"
	    return $msg
	}
	Port {
	   set msg "Enter the destination
port number
-> this will work
if you use the same
port number like
the person you are calling
so please check this"
	    return $msg  
	}
	Protocol {
	    set msg "Choose the protocol"
	    return $msg
	}
	Coding {
	    set msg "Select type
of coding for the
media session:
The coding will change
depending the media
device you want to use"
	    return $msg
	}
	invite {
	    set msg "Press to
invite a person"
	    return $msg
	}
	title {
	    set msg "Enter a string 
that identifies 
the conference"
	    return $msg
	}
	ttl {
	    set msg "Enter a time-to-live
value for IP datagrams:
-> e.g. 1, 16, 127"
	    return $msg
	}
	cancel {
	    set msg "Close this window"
	    return $msg
	}
	audio1 {
	   set msg "Select or deselect"
	    return $msg 
	}
	audio2 {
	    set msg "Choose between protocols
such as RTP and VAT"
	    return $msg 
	}
	audio3 {
	    set msg "Select 
a type of coding
such as:
PCMU, DVI4, GSM,
LPC, L16"
	    return $msg
	}
	video1 {
	    set msg "Select or deselect"
	    return $msg
	}
	video2 {
	   set msg "Select protocol such
as RTP. Choose ATM 
only if your
tool supports ATM"
	    return $msg   
	}
	video3 {
	   set msg "Select a type 
of coding 
such as:
H.261, MPEG,
and JPEG"
	    return $msg 
	}
	picture1 {
	    set msg "Select or deselect"
	    return $msg	
	}
	picture2 {
	    set msg "Select protocol such
as RTP. Choose ATM 
only if your
tool supports ATM"
	    return $msg 	    
	}	
	picture3 {
	    set msg "Select coding 
such as: JPEG"
	    return $msg
	}
	rsvp1 {
	   set msg "Select or deselect"
	    return $msg 
	}
	ifloor1 {
	   set msg "Select or deselect
floor control"
	    return $msg 
	}
	ifloor2 {
         set msg "Select 
media to be controlled:
audio or video
-> This is important
to avoid several members 
speaking in the same time"
	    return $msg
        }
	netghost1 {
	    set msg "Select or deselect"
	    return $msg
	}
	netghost2 {
        set msg "Please select 
a type of protocol"
	    return $msg 
         }
	netghost3 {
        set msg "Please select 
a type of coding"
	    return $msg
       }
	vote1 {
	     set msg "Select or deselect"
	    return $msg
	}
	add_media {
	    set msg "Adds new media tools
to the session or starts 
a new conference"
	    return $msg
	}
	invite {
	    set msg "Press here to invite people"
	    return $msg
	}
	invitation_handler {
	    set msg "Specify how to react 
to invitations:
reply to all,
temporary or permanent forward,
subject and people dependent"
	    return $msg
	}
	configure_session {
	    set msg "User specific settings can
be entered here such
as mailcap entries, source
description or profile"
	    return $msg
	}
	control_session {
	    set msg "Select/deselect 
control options:
receiver: display all incoming data
conferencing: display all members
teleteaching: display only active members"
	    return $msg
	}
	help {
            set msg "Here you can look for help"
	    return $msg
        }
	control {
         set msg "Press here to control the media"
	    return $msg
         }
	leave {
	    set msg "Close
existing media types
by clicking on them 
or exit ISC"
	    return $msg
	}
	sessions {
	    set msg "Check the
settings of the
active session tools such
as audio/video formats etc."
	    return $msg
	}
	config_media {
         set msg "To configure the
media press here"
	    return $msg
         }
	control_media {
            set msg "You can activate 
or turn off the media
using the left mouse click
or display statistics
using the middle mouse click"
	    return $msg
	}
	enlarge {
	    set msg "Pressing here will 
enlarge the window size"
	    return $msg 
	}
	preferences {
	    set msg "Choose either LAN or WAN configuration.
There are Default and User defined values.
" 
	    return $msg
	}
	t {
	    set msg "SPEC type:
0: Generic SPEC
1: Controlled Load
2: Guaranteed Load"
	     return $msg
	}
	b {
	    set msg "Token bucket depth in bytes"
	    return $msg
	}
	r {
	    set msg "Token bucket avg rate in bytes/s"
	    return $msg
	}
	p {
	    set msg "Peak data rate in bytes/s"
	    return $msg
	}
	m {
	    set msg "Min policed unit in bytes"
	    return $msg
	}
	M {
	    set msg "Max policed unit in bytes"
	    return $msg
	}
	netghostpath {
	    set msg "Specify the path"
	    return $msg
	}
	netghosthost {
	    set msg "Specify the host where to find the postscript file.
   This information is usually transmitted by 
   the netghost sender and 
   will be displayed here.
   This can take up to 30sec."
	    return $msg
	}
	netghostmode {
	    set msg "You can act as sender or receiver for netghost.
     When you are acting as a sender 
     your host and path information 
     will be broadcasted to all receivers."
	    return $msg
	}
	netghostlocation {
	    set msg "A file can be located on your local harddisc 
                     or downloaded from the WorldWideWeb"
	    return $msg
	}
	
	default {
	    set msg "no text defined for flag=$flag"; return $msg
	}

    }
    set msg "
no text defined for 
this button=$flag"; 
    return $msg

}

