#
# Remove element 'e' from variable 'v'.
#
proc lremove {v e} {
    upvar $v var 
   
    set i [lsearch $var $e]
    if {$i >= 0} {
	set var [lreplace $var $i $i]
    }
}

#
# Add 'e' to 'v' only if not in list already. Sort list.
#
proc ladd {v e} {
  upvar $v var

  set i [lsearch $var $e]
  if {$i < 0} {
    lappend var $e
  }
  set var [lsort $var]
}
#
# remove an entry from a list
# arg is the value of the index to be removed from list
# return the new list
proc remove_entry {list arg} {
    if {[lsearch -exact $list $arg] >=0 } {
	set list [lreplace $list [lsearch -exact $list $arg] \
		      [lsearch -exact $list $arg] ""]
	set list_tmp ""
	set list [lsort -ascii -decreasing $list]
	for { set i 0} {$i <[expr [llength $list] -1]} {incr i} {
	    lappend list_tmp [lindex $list $i]
	}
	set list $list_tmp
    }
    return $list

}
