set env(JSNLIB) /apps/lib/tkJason

global dlist_ok dlist_dir

proc createGUI {} {
    global env

    wm title . "Jason Startup Menu"
    wm iconname . "Jason"

    frame .logo -relief raised -borderwidth 1
        label .logo.lbl  \
            -anchor e -padx 5
        pack .logo.lbl
    pack .logo -side left


    frame .fm -relief raised -borderwidth 1

        frame .fm.menu -relief raised -borderwidth 2
        menubutton .fm.menu.file -text "File" \
            -underline 0 \
            -menu .fm.menu.file.m
        menu .fm.menu.file.m
            .fm.menu.file.m add command \
                -label "Change Directory" \
                -command chgdirquery
            .fm.menu.file.m add command \
                -label "Save Settings" \
                -command savesettings
            .fm.menu.file.m add command \
                -label "Exit" \
                -command exit
        menubutton .fm.menu.apps -text "Applications" \
            -underline 0 \
            -menu .fm.menu.apps.m
        menu .fm.menu.apps.m
            .fm.menu.apps.m add command \
                -label "Seismic Lithology Workstation..." \
                -command start_jgw
        menubutton .fm.menu.util -text "Utilities" \
            -underline 0 \
            -menu .fm.menu.util.m
        menu .fm.menu.util.m 
            .fm.menu.util.m add command \
                -label "Unix Window..." \
                -command start_xterm 
        pack .fm.menu.file .fm.menu.apps .fm.menu.util -side left \
            -pady 5
        pack .fm.menu -anchor e -side left -fill x -expand yes
    
    pack .fm -after .logo -expand yes -fill both

    frame .info -relief raised -borderwidth 1
        label .info.l1 -text "Current directory: [pwd]" -anchor e \
            -pady 5 -padx 5
        pack .info.l1 -padx 5
    pack .info -side bottom -before .logo -fill x -expand yes
}
 
proc start_jgw {} {
    global env
        set cmdstr {/apps/bin/jason}
        exec csh -c $cmdstr &
}
 
proc start_xterm {} {
    global env
    set cmdstr {xterm}
    exec csh -c $cmdstr &
}

proc chgdirquery {} {
    global dlist_dir dlist_ok
    global env

        if {![winfo exists .save]} {
        createDirChoice .save $dlist_dir
        } else {
                wm deiconify .save
        }
}

proc dirSelHelpCmd {} {
        puts [format "help is on the way"]
}

proc savesettings {} {
    global env
    
    set fsave [open "~/.jasonrc" "w"]
    puts $fsave [format "%s" [pwd]]
    close $fsave
}

proc readsettings {} {
    global env
    global dlist_dir dlist_ok

    if {[file exists "~/.jasonrc"]} {
        set fsettings [open "~/.jasonrc" "r"]
        while {[gets $fsettings line] >= 0} {
            set dlist_dir $line
        }
        close $fsettings
        if {[file isdirectory $dlist_dir]} {
            cd $dlist_dir
        } else {
            puts stderr [format "%s" "Directory $dlist_dir not found"]
            puts stderr [format "%s" "Will start Jason in current
directory"]
        }
    } else {
        set dlist_dir [pwd]
    }
}

proc createDirChoice {w $dlist_dir} {
    global dlist_dir

    set dlist_ok false

    toplevel $w 
    frame $w.f -border 1 -relief raised
        
    entry $w.f.ent \
        -textvariable dlist_dir 
    bind $w.f.ent <Return> "setDirTree $w"

    tixDirList $w.f.dirlst \
        -command "setDirName $w"

    pack $w.f.dirlst $w.f.ent \
        -padx 20 -pady 10 \
        -side top -fill both -expand yes

    tixButtonBox $w.btnbox -orientation horizontal 
        $w.btnbox add ok -text "OK" -command "okcmd $w" \
            -underline 0 -width 6
        $w.btnbox add cancel -text "Cancel" -command "wm withdraw $w" \
            -underline 0 -width 6

    pack $w.f $w.btnbox \
        -side top -fill both -expand yes

    if {[file isdirectory $dlist_dir]} {
        $w.f.dirlst chdir $dlist_dir
    } else {
        $w.f.dirlst chdir [pwd]
    }
    set dlist_dir [$w.f.dirlst cget -value]
}

proc setDirName {w dirname} {
    global dlist_dir
    set dlist_dir $dirname
    set viewrange [$w.f.ent xview]
    set viewdiff [expr [lindex $viewrange 1] - [lindex $viewrange 0]]
    $w.f.ent xview moveto [expr 1.0 - $viewdiff]
}

proc setDirTree {w} {
    global dlist_dir
    
    if {[file isdirectory $dlist_dir]} {
        $w.f.dirlst configure -value $dlist_dir
        $w.f.dirlst chdir $dlist_dir
    } else {
        puts stderr [format "%s" "Value entered is not a directory"]
    }
}

proc okcmd {w} {
    global dlist_dir dlist_ok

    set dlist_ok true
    wm withdraw $w 
    cd $dlist_dir
    .info.l1 config -text "Current directory: $dlist_dir"
}

proc getJasonParent {} {
    global tcl_platform
    set jasonParent [format "/apps/%s/%s/Jason" \
        $tcl_platform(os) [string range $tcl_platform(osVersion) 0 0]]
    return $jasonParent
}

##### Main Program #####

set env(JASON) [getJasonParent]
readsettings
createGUI

