set media(pcm)         "audio {PCMU 1 8000} 0.02"
set media(pcm2)        "audio {PCMU 1 8000} 0.04"
set media(pcm4)        "audio {PCMU 1 8000} 0.08"
set media(idvi)        "audio {DVI4 1 8000} 0.02"
set media(dvi)         "audio {DVI4 1 8000} 0.02"
set media(dvi2)        "audio {DVI4 1 8000} 0.04"
set media(dvi4)        "audio {DVI4 1 8000} 0.08"
set media(gsm)         "audio {GSM  1 8000} 0.08"
set media(lpc)         "audio {LPC  1 8000} 0.02"
set media(lpc4)        "audio {LPC  1 8000} 0.08"
set media(h261)        "video {H261} 0"
set media(ivs)         "video {H261} 0"
set media(vic)         "video {H261} 0"

set media(PCMU)        "audio"
set media(DVI)         "audio"
set media(LPC)         "audio"
set media(GSM)         "audio"
set media(L16)         "audio"
set media(H261)        "video"
set media(JPEG)        "video"
set media(CelB)        "video"

# mapping of RTP media to vat media
set media(PCMU,1,8000,0.02) "pcm"
set media(PCMU,1,8000,0.04) "pcm2"
set media(PCMU,1,8000,0.08) "pcm4"
set media(DVI4,1,8000,0.02) "dvi"
set media(DVI4,1,8000,0.04) "dvi2"
set media(DVI4,1,8000,0.08) "dvi4"
set media(GSM,1,8000,0.08)  "gsm"
set media(LPC,1,8000,0.02)  "lpc"
set media(LPC,1,8000,0.08)  "lpc4"
 
#
# sd/vat format list
#
proc sd {argv} {
  global Session session media

  foreach s $argv {
    set fmt ""
    set c [split $s /]
    set Session(host)     [lindex $c 0]
    set Session(port)     [lindex $c 1]
    if {[llength $c] > 2} {
      set Session(confid) [lindex $c 2]
    }
    if {[llength $c] > 3} {
      set fmt             [lindex $c 3]
    }
    if {[llength $c] > 4} {
      set Session(ttl)    [lindex $c 4]
    }
    if {$fmt != ""} {
      if [info exists media($fmt)] {
        set Session(type)  [lindex $media($fmt) 0]
        set Session(media) [lindex $media($fmt) 1]
        set Session(frame) [lindex $media($fmt) 2] 
      } else {
        set f [split $fmt ,]
        if [info exists media([lindex $f 0])] {
          set Session(type)  $media([lindex $f 0])
          set Session(media) $f
          set Session(frame) 0
        } else {
          return -code error "Unknown media $fmt"
        }
      }
    }
    # create session and wait until session has been created
    tkwait variable session([session_create],created)
  }
}
