set Max_y 1
set Max_x 1


set Width 350 
set Height 300
set W_Edge 40
set H_Edge 40
set Curve_W [expr $Width  - (2*$W_Edge)]
set Curve_H [expr $Height - (2*$H_Edge)]

set X_Zero $W_Edge
set Y_Zero [expr $Curve_H+$H_Edge]


proc graph {w title x_axis} {
    global  Curve_H Curve_W X_Zero Y_Zero members W_Edge H_Edge Width Height

    if { [winfo exists $w]} {
	destroy $w
    }

    canvas $w -width $Width -height $Height
    $w create rectangle [expr $Curve_W+$W_Edge] [expr $Curve_H+$H_Edge]\
	$W_Edge $H_Edge  -outline black -fill white -tag rec_$w

    $w create text \
	[expr $Width/2] [expr $H_Edge-20]  -text $title -justify center 
    $w create text \
	[expr $Width/2] [expr $Height-$H_Edge+30] -text $x_axis -justify center

    pack $w

    set members($w,div) 0
    set members($w,Max_x) 1
    set members($w,Max_y) 1
    set members($w,Div_x) 10
    set members($w,Div_y) 10
}

proc element {w list_x list_y} {
    global W_Edge H_Edge Width Height members Curve_W Curve_H

    set members($w,Div_x) 10
    set members($w,Div_y) 10

    set members($w,Max_x)   [lindex $list_x [expr [llength $list_x]-1 ]]

    set value_y [lindex $list_y [expr [llength $list_y]-1 ]]
    if { $value_y > $members($w,Max_y) } {
	set members($w,Max_y) $value_y
    }
    if { $members($w,Max_y) < $members($w,Div_y) } {
	set members($w,Div_y) $members($w,Max_y)
	if { $members($w,Div_y) <=1 } {
	    set members($w,Div_y) 2
	}
    }

    if { $members($w,Max_x) < $members($w,Div_x) } {
	set members($w,Div_x) $members($w,Max_x)
	if { $members($w,Div_x) <=1 } { 
	    set members($w,Div_x) 2
	}
     }
    
    if { $members($w,div) >0 } {
	# delete the old tags
	$w delete {$w_tag_div}
    }

    # draw the x axis
    for { set i 0} {$i <= $members($w,Div_x) } {incr i} {
puts " Div_x=$members($w,Div_x) max_x=$members($w,Max_x)"
	$w create text \
	    [expr ($W_Edge )+(($i*$Curve_W)/($members($w,Div_x)))] \
	    [expr $Height -$H_Edge +10] \
	    -text [expr ($i*$members($w,Max_x))/$members($w,Div_x)] \
	    -justify center -tag {$w_tag_div}
	set members($w,div) $members($w,Div_x)
    }

    #draw the y axis
    for { set i 0} {$i <= $members($w,Div_y) } {incr i} {
	set value \
	    [format "%.1f" [expr ($i*$members($w,Max_y))/$members($w,Div_y)]]
	$w create text   [expr $W_Edge -20] \
	    [expr ($Height -$H_Edge)-(($i*$Curve_H)/$members($w,Div_y))] \
	    -text $value -justify right -tag {$w_tag_div}
    }	
    draw $w $list_x $list_y
}


# draw the actual curve    
proc draw {w list_x list_y} {
    global List Curve_W Curve_H X_Zero Y_Zero  members

    set length [expr [llength $list_x]-1 ]
    for { set i 0} {$i <= $length} {incr i} {
	# scale the single points with the actual size of the curve
	set List [lappend List \
		 [expr ([lindex $list_x $i]*$Curve_W)/($members($w,Max_x)+1)]]
	set List [lappend List \
		[expr ([lindex $list_y $i]*$Curve_H)/($members($w,Max_y)+1)]]
    }
    #clean up the last curve 
    $w delete -tag {$w_rec_tag}

    set x1 $X_Zero
    set y1 $Y_Zero
    #draw a new curve
    set length [expr [llength $List]/2]
    for { set i 0} {$i < $length} {incr i} {
	set x2 [expr [lindex $List [expr ($i*2)]]+$X_Zero]
	set y2 [expr $Y_Zero - [lindex $List [expr ($i*2)+1]]]
	$w create line $x1 $y1  $x2 $y2 \
	    -fill green -tag {$w_rec_tag}
	set x1 $x2
	set y1 $y2
    }
    unset List
}


toplevel .stat
wm title .stat lllll

graph .stat.g Test seconds
element .stat.g {0 } {0}
element .stat.g {0 1} {0 1}
element .stat.g {0 1 10 } {0 1 20}
element .stat.g {0 1 10 20 } {0 1 20 25}
element .stat.g {0 1 10 20 30} {0 1 20 25 100}
element .stat.g {0 1 10 20 30 40} {0 1 20 25 100 30}
element .stat.g {0 1 10 20 30 40 50} {0 1 20 25 100 30 40}
element .stat.g {0 1 10 20 30 40 50 60} {0 1 20 25 100 30 40 110}
element .stat.g {0 1 10 20 30 40 50 60 70} {0 1 20 25 100 30 40 110 10000}

toplevel .stat2
wm title .stat2 lllll

graph .stat2.g Test seconds
element .stat2.g {0 } {0}
element .stat2.g {0 1} {0 1}
element .stat2.g {0 1 10 } {0 1 20}
