/*
strcpy_pad  --  like strcpy, but pad to next word boundary

Copyright 1993 by AT&T Bell Laboratories; all rights reserved
*/

static char rcsid[] = "$Id: strcpy_pad.c,v 1.1.1.1 1997/11/12 17:16:08 dor Exp $";

/*
* d  I   destination character pointer
* s  I   source character pointer; if 0, treat as zero-length string.
* Pads with binary zeroes, but does not write zero unless needed for
* padding.  Returns total number of bytes copied, including padding.
*/
int strcpy_pad(char *d, char *s)
{
  char *d0 = d;

  if (!d || !s) return 0;
  while ((*d++ = *s++)) ;
  while ((unsigned long)d & 0x03) *d++ = '\0';

  return d - d0;
} /* strcpy_pad */
