/*
 * xil_capture.h 
 *
 * variables and structures need for the xil grab operations
 *
 * (C) 1996 Dorgham Sisalem
 *
 *  See the copyright file for copyright information
 */


#ifndef CAPTURE_H
#define CAPTURE_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/XShm.h>
#ifdef XIL
#include <xil/xil.h>
#endif
#include <sys/time.h>


enum compressor_type {
    JPEG, MPEG, CELLB, UYVY
};
#define MAXSENDTO       32

typedef struct {
    char hostname[MAXSENDTO][64];
    int hostnameknt;
    char *cis_type;
    enum compressor_type do_cis;
    int x, y;
    int width, height;
    int scalex;
    int scaley;
    int channel;
    int frames;
    int preview;
    int whichinput;
    char *devname;
    char *windowname;
    int image_skip;
    int scale;
    int max_buffer;
    char *datafile;
    int cellb_xy_addr;
    int transmit;
    int polling;
    int error_out;
    char *pattern;
    int quality;
} xil_grab_parameters;
#ifdef XIL
typedef struct {
        XilImage rtvc_image;
        XilSystemState state;
        XilImage image;
        XilImage scaled_image;
        XilCis cis;
        struct timeval t;
        int nbytes,nframes;
        Xil_unsigned8 data;
	int scalex,scaley,preview;
} xil_parameters;

extern  init_grab_par(xil_grab_parameters *param);
extern  cis_put_bits(int nbytes,int frames,char *image);






extern initialize_window(xil_grab_parameters * param, XilSystemState state);
extern void display(XilCis cis);
#endif
extern  int display_frame(char* image,int len,char * decoder);
extern  display_fr(int nbytes,int frames,char *image);
extern void resize(int w, int h);
extern void close_window();
extern char* init_diaply(char *decoder);


#endif
