/* 
 * xv.h --
 *
 * Contains the variables and structures needed for the imge display
 *
 * Copyright (c) 1996 by Dorgham Sisalem GMD fokus all rights reserved.
 *
 * 
 *  See the copyright file for copyright information
 *
 */

#include <sys/param.h>
#include <sys/types.h>


#undef PARM
#ifdef __STDC__
#  define PARM(a) a
#else
#  define PARM(a) ()
#  define const
#endif



/*************************************************/
/* START OF MACHINE-DEPENDENT CONFIGURATION INFO */
/*************************************************/

#include <X11/Xos.h>     /* need type declarations immediately */

/*********************************************************/


/* include files */
#include <stdio.h>
#include <math.h>
#include <ctype.h>

#ifdef __STDC__
#  include <stddef.h>
#  include <stdlib.h>
#endif

/* note: 'string.h' or 'strings.h' is included by Xos.h, and it
   guarantees index() and rindex() will be available */

#ifndef VMS
#  include <errno.h>
   extern int   errno;             /* SHOULD be in errno.h, but often isn't */
#  ifndef __NetBSD__
     extern const char *const sys_errlist[];     /* this too... */
#  endif
#endif


/* not everyone has the strerror() function, or so I'm told */
#ifndef VMS
#  define ERRSTR(x) sys_errlist[x]
#else
#  define ERRSTR(x) strerror(x, vaxc$errno)
#endif


#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/extensions/XShm.h>
#include <tk.h>

#define MAIN
#define NEEDSTIME
#define NEEDSDIR     /* for value of MAXP ATHLEN */




typedef struct {
  XImage        *theImage;
  GC             theGC;
  Window         mainW;
  Window         xilW;
  GC             theGC_o;
  Visual        *theVisual;
  Display       *theDisp;
  Tk_Window      childWindow;
  int            dispDEEP;
  Pixmap         pixmap;
  char          *name;
  char           child_name[20];
  XShmSegmentInfo *shminfo;
  char           command[100];
  int            busy;
  char           where[20];
  int            width;
  int            restart;  /*set to 1 when started or after resizing */
}video_map_struct;


#ifndef MAIN
#define WHERE extern
#else
#define WHERE
#endif

WHERE Colormap      theCmap;
#undef WHERE



/* function declarations for externally-callable functions */

/****************************** XV.C ****************************/
int FatalError       PARM((char *));
void end_TkAll       PARM((int));
int  end_TkStuff     PARM((char *name));
void drawWindow      PARM((int,int,int,int,char*,char*,char*,char*,char*,char* ));
int do_TkStuff       PARM((int*,int*,int*,int*,int*,int,int,int*,char *,int (*xil_stuff)()));
int do_XilStuff      (int, int, int);
int ignore_XilStuff  (int, int, int);



extern void clear_video_map0();
extern void restart_Tk_up(int window,int scale);
extern void restart_Tk_down(int scale);
extern int init_video_map();
extern int get_map(char *name,int width);
extern void clear_TkAll() ;




















