/*
 * vat_session.h: definitions for oob control messages
 * The values are chosen so that the default (0) is sensible.
 * $Id: vat_session.h,v 1.1.1.1 1997/11/12 17:16:34 dor Exp $
 */

#define MAX_VAT_SITE 512
#include "types.h"
typedef struct {
  u_int32 addr;           /* IP address */
  char id[MAX_VAT_SITE];  /* descriptor */
} vat_site_id_t;

/* session message */
typedef struct {
  u_int8 flags;        /* ???; currently zero */
  u_int8 type;         /* message type, of type session_type (below) */
  u_int16 confid;      /* conference identifier */
  union {
    char id[MAX_VAT_SITE];      /* variable length data part */
    struct {
      u_char nsids;             /* number of site_id entries */
      u_char ainfo;             /* audio flags, audio format */
      u_int16 blksize;          /* audio block size */
      vat_site_id_t site_id;    /* nsids of these */
    } idlist;
  } d;
} session_t;

typedef enum {vat_id = 1, vat_done, vat_idlist} vat_session_t;
