/*
* hp_sys  --  emulation of system routines for HP
*/



#include "types.h"
#include <sys/utsname.h>
#include <math.h>         /* HUGE_VAL */
#include <stdlib.h>       /* srand48(), lrand48() */
#include <time.h>
#include "arch_sys.h"

double infinity(void)
{
  return HUGE_VAL;
} /* infinity */


void srandom(int seed)
{
  srand48((long)seed);
} /* srandom */


long random(void)
{
  return lrand48();
} /* random */


long gethostid(void)
{
  struct utsname name;

  uname(&name);
  return atoi(name.idnumber);
} /* gethostid */


int gmtoff(void)
{
  time_t clock;
  struct tm *tm;

  time(&clock);
  tm = localtime(&clock);
  return tm->tm_isdst ? timezone+3600 : timezone;
} /* gmtoff */
