proc pmm_audioctl {} {
    global in_list out_list tkaudio_library gain
    global record play monitor isc_active_flag

    set isc_active_flag 0
    after 20000 check_isc_activity
    set a [ports]
    set in_list  [lindex $a 0]
    set out_list [lindex $a 1]

    if {![info exists gain(microphone_in)]} {
	set gain(microphone_in) $record(gain)
    }
    if {![info exists gain(line_in)]} {
	set gain(line_in) $record(gain)
    }
    if {![info exists gain(digital_in)]} {
	set gain(digital_in) $record(gain)
    }
    if {![info exists gain(line_out)]} {
	set gain(line_out) $play(gain)
    }
    if {![info exists gain(digital_out)]} {
	set gain(digital_out) $play(gain)
    }
    if {![info exists gain(speaker_out)]} {
	set gain(speaker_out) $play(gain)
    }
    if {![info exists gain(headphone_out)]} { 
	set gain(headphone_out) $play(gain) 
    } 
    if {![info exists gain(monitor)]} { 
	set gain(monitor) $monitor(gain) 
    } 
    
    trace variable record(port)  w rec_port_trace 
    trace variable play(port)    w play_port_trace 
    trace variable record(gain)  w rec_gain_trace 
    trace variable play(gain)    w play_gain_trace 
    #trace variable monitor(gain) w monitor_gain_trace 


    # transmit current settings
    control_send "*/au_ctrl/* play(port) $play(port)"
    control_send "*/au_ctrl/* record(port) $record(port)"
    control_send "*/au_ctrl/* record(gain) $record(gain)"
    control_send "*/au_ctrl/* play(gain) $play(gain)"
    #control_send "*/au_ctrl/* monitor(gain) $monitor(gain)"
} 


proc rec_port_handler {} { 
    global record in_list 
   
    set rp $record(port) 
    set record(port) [lindex $in_list [expr ([lsearch $in_list $rp]+1)%[llength $in_list]]] 
    control_send "*/au_ctrl/* record(port) $record(port)"
}
 
proc rec_port_trace {name element op} { 
    global record gain 
    
    if {$gain($record(port)_in) != "*"} { 
	set record(gain) $gain($record(port)_in) 
    }
    control_send "*/au_ctrl/* record(port) $record(port)"
} 

proc play_port_handler {} { 
    global play out_list 
    set play(port) [lindex $out_list [expr ([lsearch $out_list $play(port)]+1)%[llength $out_list]]] 
    control_send "*/au_ctrl/* play(port) $play(port)"
} 

proc play_port_trace {name element op} { 
    global gain play 
    if {$gain($play(port)_out) != "*"} { 
	set play(gain) $gain($play(port)_out) 
    } 
    control_send "*/au_ctrl/* play(port) $play(port)"
} 

proc rec_gain_trace {name1 name2 op} { 
    global record gain 
    set gain($record(port)_in) $record(gain) 
    control_send "*/au_ctrl/* record(gain) $record(gain)"
} 

proc play_gain_trace {name1 name2 op} { 
    global play gain 
    set gain($play(port)_out) $play(gain) 
    control_send "*/au_ctrl/* play(gain) $play(gain)"
} 

proc monitor_gain_trace {name1 name2 op} { 
    global monitor gain
    set gain(monitor) $monitor(gain)
    control_send "*/au_ctrl/* monitor(gain) $monitor(gain)"
} 

# check pid file
if [file exists "/var/tmp/pmm_audioctl.pid"] {
    puts "Another copy of pmm_audioctl seems to run"
    exit
}
# create pid file
if [catch {open /var/tmp/pmm_audioctl.pid w+} fileId] {
    puts "Can't create pid file"
    exit
} else {
    puts $fileId [pid]
    close $fileId
}

# clear audio device
#if [catch {set audio_fd [open /dev/audio {NONBLOCK RDWR}]}] {
#    exec rm /var/tmp/pmm_audioctl.pid
#    exit
#}
#close $audio_fd
set debug 0
control_init {udp 225.2.0.1 5010}
pmm_audioctl
  
