#include <tcl.h>
#include <stdlib.h>  /* getenv() */
#include "tkaudio.h"
#include "ahw.h"
#include <signal.h>


#include "tcl/pmm_audioctl.c"
#include "tcl/control_udp.c"
#include "tcl/control_audioctl.c"
#include "tcl/audioctl_param.c"
#define TE(x) if (Tcl_Eval(interp, x) != TCL_OK) fprintf(stderr," failed %s",interp->result);;

Tcl_Interp *Interp;  /* for tkaudio poll handler */
Tcl_Interp *interp;


/*
 * parse online arguments
 */
int parse_online(int argc, char *argv[])
{
  extern char *optarg;
  extern int optind;
  char command[100];
  char c;
  while ((c = getopt(argc, argv, "A:h")) != EOF) {
 
    switch(c) {
    case 'A':
      sprintf(command,"audioctl_parameters %s %s","A",optarg);
      if (Tcl_Eval(interp, command) !=TCL_OK)
	fprintf(stderr," failed %s \n",interp->result);
      break;
 
    case 'h':
      fprintf(stderr,"usage: pmm_audioctl\n");
      Exit();
    }
  }
  return 1;
}





int tkaudio_init(Tcl_Interp *interp,int argc,char** argv)
{
  extern int source_file(Tcl_Interp *interp, char *file);
  extern char *tkaudio_set();
  extern int tkaudio_ports();
  extern void tkaudio_poll(int);
  extern void tkaudio_timer(ClientData);
  extern int tkaudio_state();

  extern int Tcl_SetSockBuffer_cmd(ClientData clientData, Tcl_Interp *interp, 
			  int argc, char **argv);

  int i;

fprintf(stderr, " XXXX2 ");
  Interp = interp; 
  tkaudio_timer(0);  /* initialize variables and signal handler */
  Tcl_CreateCommand(interp, "ports", tkaudio_ports, 0, 0);
  Tcl_CreateCommand(interp, "audio_state", tkaudio_state, 0, 0);
  Tcl_CreateCommand(interp, "Tcl_SetSockBuffer", Tcl_SetSockBuffer_cmd, 0, 0);
  Tcl_TraceVar2(interp, "record",  "gain", TCL_TRACE_WRITES, 
    tkaudio_gain_trace, (ClientData)0);
  Tcl_TraceVar2(interp, "play",    "gain", TCL_TRACE_WRITES,
    tkaudio_gain_trace, (ClientData)1);
  Tcl_TraceVar2(interp, "monitor", "gain", TCL_TRACE_WRITES,
    tkaudio_gain_trace, (ClientData)2);
  Tcl_TraceVar2(interp, "record",  "port", TCL_TRACE_WRITES,
    tkaudio_port_trace, (ClientData)0);
  Tcl_TraceVar2(interp, "play",    "port", TCL_TRACE_WRITES,
    tkaudio_port_trace, (ClientData)1);
  ahw_track(tkaudio_poll);


  TE(control_audioctl_tcl)
  TE(control_udp_tcl)
  TE(audioctl_param_tcl)
  parse_online(argc,argv);
  TE(pmm_audioctl_tcl)
    
    for (i = 0; i < 2; i++) {  
      char *dir = i ? "record" : "play";  
      
      Tcl_SetVar2(interp, dir, "errors", "0", 0);  
      Tcl_SetVar2(interp, dir, "active", "0", 0);  
    }  
  
  
  return TCL_OK;
} /* tkaudio_init */


void Exit ()
{

  remove ("/var/tmp/pmm_audioctl.pid");
  exit (0);
} /* Exit */
void Ignore ()
{
return;
} /* Ignore */




int main (int argc,char **argv)
{
  extern int Udp_Init(Tcl_Interp *interp);
  extern int source_file(Tcl_Interp *, char *);

  signal(SIGINT, Exit);
  signal(SIGKILL, Exit);
  signal(SIGTERM, Exit);
  signal(SIGQUIT, Exit);
  signal(SIGABRT, Exit);
  signal(SIGBUS, Exit);
  signal(SIGCHLD, Ignore);

  interp = Tcl_CreateInterp();

  if (Udp_Init(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }
  if (tkaudio_init(interp,argc,argv) == TCL_ERROR) {
    return TCL_ERROR;
  }
  while (1) { /* start event handler */
    /*
     * Tk doesn't give priority to the X server so file handlers
     * (i.e., packets from the network) can starve the window
     * system (technically, tk lets one X event through per file
     * event, but a file event can trigger more than one X event
     * so the X server loses to a high-rate video source).
     * The solution is to let the X server go first by only
     * processing file handlers when their are no pending
     * X events.
     */
    if (Tcl_DoOneEvent(TCL_WINDOW_EVENTS|TCL_IDLE_EVENTS|TCL_DONT_WAIT)==0)
      Tcl_DoOneEvent(0);
  }
  return 0;			/* Needed only to prevent compiler warning. */
}


