/*
* If the file exists, source it. The file name may contain Tcl
* expressions and tildes. It is no error if the file doesn't exist.
* Call Tk_BackgroundError if evalution yields error. Return 0 if
* file exists, -1 otherwise.
*/
#include <tcl.h>
#include <tk.h>     /* Tk_BackgroundError() */
#include <string.h>

static char rcsid[] = "$Id: source_file.c,v 1.1.1.1 1998/04/21 17:05:50 sho Exp $";

int source_file(Tcl_Interp *interp, char *name)
{
  int code;

  if (Tcl_VarEval(interp, "file readable ", name, NULL) == TCL_OK) {
    if (strcmp(interp->result, "1") == 0) {
      code = Tcl_VarEval(interp, "source ", name, NULL);
      if (code != TCL_OK) Tk_BackgroundError(interp);
    }
    else return -1;
  }
 
  return 0;
} /* source_file */
