#
# Tcl client for getting all hosts where user might be
# Return list of hosts where user might be logged on
#

set prior [pwd]

if {[catch {cd $lswhod_db/$user}]} {
    exit
}

if {[catch {set hosts [glob *]}]} {
    exit
}

set where {}
foreach h $hosts {
    if {[file size $h] == 0 && [lsearch $where $h] < 0} {
	lappend where $h
    } else {
	set f [open $h r]
	while {[gets $f line] >= 0} {
	    foreach host $line {
		if {[lsearch $where $host] < 0 && $host != ""} {
		    lappend where $host
		}
           }
	}
    }
}

cd $prior
puts [join $where \n]
return TCL_OK	

